;===========================================================================
;======= PROTECTION v1.5      (c)1997 Fock Ping Olivier (09/05/97)
;
;                (source en ASM 68K)
;
; Ce programme a t test sur TI-92 avec ROM version 1.5 (02/01/96)
; et avec Fargo version 0.1.13.
;
; PROTECTION a t conu pour protger par mot de passe l'accs  la TI-92.
; Le mot de passe est limit  10 caractres. (par dfaut : passe)
; Si le compte  rebours atteint zro, alors la calculatrice s'teindra et la
; protection s'activera. 
;
; [F1]  : Eteindre la TI-92 et activer la protection immdiatement
; [F2]  : Changer le mot de passe
;            - Tapez d'abord l'ancien mot de passe
;            - Ensuite le nouveau mot de passe
;            - Confirmez en entrant de nouveau le mot de passe
; [F3]  : Option
;          * Changer la valeur du time out (1-60 secondes)
; [F4]  : Quitter le programme PROTECTION
;
;
;
; ATTENTION ! Ce programme peut rendre la TI-92 inutilisable en quelques
; secondes...
; Si vous avez perdu le mot de passe, vous serez contraints de faire un RESET
; (LOCK+2nd+ON).
; Je dcline toute responsabilit concernant les problmes qui pourraient
; survenir lors de l'utilisation de ce programme.

        include protec.h

        @program        pcode,pname

pcode:
        bsr           Info
        WriteStr      #35,#40,#4,m1
        WriteStr      #35,#50,#4,m2
        WriteStr      #35,#60,#4,m3
        WriteStr      #35,#70,#4,m4
        move.b        #1,d4
        move.b        #1,Rebours
menu:
        bsr           ShutOff
        IfThen        #2000,d0,lockcalc
        IfThen        #13,d0,lockcalc
        Ifthen        #268,d0,lockcalc
        Ifthen        #269,d0,ChangePassword
        Ifthen        #270,d0,ChangeWait
        Ifthen        #271,d0,Done
        Ifthen        #264,d0,Done
        bra           menu

ChangePassword:
        clr.b         d4
        bsr           GetPassword
        IfNotThen     #1,d0,pcode

ChangePassword_GetNewPassword:
        bsr           Info
        WriteStr      #10,#55,#4,nPassword
        SetFont       #0
        WriteStr      #150,#65,#4,limite
        SetFont       #2
ChangePassword_GetNewPassword_nul:
        lea           Password(pc),a2
        bsr           GetString
        IfThen        #0,d3,ChangePassword_GetNewPassword_nul
        move.b        #0,(a2)+
        lea           PasswordLength(pc),a1
        move.b        d3,(a1)
        bsr           GetPassword
        IfNotThen     #1,d0,ChangePassword_GetNewPassword
        bra           pcode

lockcalc:
        bsr           Clr_Scr
        trap          #4
        move.b        #1,d4
        move.b        #0,Rebours
        bsr           GetPassword
        IfNotThen     #1,d0,lockcalc
Done:
        rts

GetPassword:
        bsr           Info
        WriteStr      #10,#55,#1,prompt
        SetFont       #2
        lea           temps1(pc),a2
        bsr           GetString
        cmp.b         PasswordLength(pc),d3
        bne           GetPassword_Wrong
        cmp.b         #0,d3
        beq           GetPassword_Correct
        lea           temps1(pc),a2
        lea           Password(pc),a3
        sub.b         #1,d3
GetPassword_CheckPassword:
        cmpm.b        (a2)+,(a3)+
        bne           GetPassword_Wrong
        dbra          d3,GetPassword_CheckPassword
GetPassword_Correct:
        move.l        #1,d0
        rts
GetPassword_Wrong:
        clr.l         d0
        rts

ShutOff:
        movem.l       a0-a6/d1-d7,-(a7)
        SetFont       #2

ShutOff_Idle_Start:
        lea           wait(pc),a2
        move          (a2),d4
        move.l        d4,APD_TIMER
        clr.w         APD_FLAG
        move.w        #ACTIVITY_IDLE,-(a7)
        jsr           romlib[set_activity]
        add.l         #2,a7
ShutOff_Wait_Idle:
        stop          #$2000
        tst.w         APD_FLAG
        beq           ShutOff_No_APD
ShutOff_Do_APD:
        movem.l       (a7)+,a0-a6/d1-d7
        move          #2000,d0
	rts
ShutOff_No_APD:
        move.l        APD_TIMER,d1
        divs          #17,d1
        cmp.b         #1,Rebours
        bne           ShutOff_No_Affiche
        clr.l         d0
        move.w        d1,d0
        moveq         #2,d1
        lea           tstr(PC),a0
        bsr           ConvStr
        WriteStr      #110,#90,#4,tstr
ShutOff_No_Affiche:
        tst.w         ($75B0)
        beq           ShutOff_Wait_Idle
        move.l        #$1770,APD_TIMER
        move.w        ($75B2),d0
        clr.w         ($75B0)
        move.l        d0,-(a7)
        move.w        #ACTIVITY_BUSY,-(a7)
        jsr           romlib[set_activity]
        add.l         #2,a7
        move.l        (a7)+,d0
ShutOff_Try_Key_OFF:
        cmp.w         #$210B,d0
        bne           ShutOff_Not_Key_OFF
        bra           ShutOff_Do_APD
ShutOff_Not_Key_OFF:
        movem.l       (a7)+,a0-a6/d1-d7
	rts

ChangeWait:
        lea           wait(pc),a2
        clr.l         d3
        bsr           Info
        WriteStr      #10,#55,#4,PChange1
        move          (a2),d5
        divs          #17,d5
        SetFont       #2

ChangeWait_KeyGet:
        move.w        d5,d0
        moveq         #2,d1
        lea           tstr(PC),a0
        bsr           ConvStr
        WriteStr      #110,#90,#4,tstr
        jsr           flib[idle_loop]
        IfThen        #338,d0,ChangeWait_KeyUp
        IfThen        #344,d0,ChangeWait_KeyDown
        IfThen        #13,d0,ChangeWait_KeyEntree
        IfThen        #264,d0,ChangeWait_Exit
        bra           ChangeWait_KeyGet

ChangeWait_KeyUp:
        IfThen        #60,d5,ChangeWait_KeyGet
        add           #1,d5
        bra           ChangeWait_KeyGet
ChangeWait_KeyDown:
        IfThen        #1,d5,ChangeWait_KeyGet
        sub           #1,d5
        bra           ChangeWait_KeyGet
ChangeWait_KeyEntree:
        muls          #17,d5
        move          d5,(a2)
ChangeWait_Exit:
        bra           pcode


Info:
        bsr           Clr_Scr
        SetFont       #2
        WriteStr      #80,#10,#0,progn
        SetFont       #0
        WriteStr      #100,#25,#1,progv
        SetFont       #1
        WriteStr      #00,#120,#1,copyr
        rts

ConvStr:
        adda.l        d1,a0
        clr.b         (a0)
        subq.b        #1,d1
RepConv:
        divu          #10,d0
        move.l        d0,d2
        lsr.l         #8,d2
        lsr.l         #8,d2
        add.b         #48,d2
        move.b        d2,-(a0)
        and.l         #$FFFF,d0
        dbra          d1,RepConv
	rts

Clr_Scr:
        lea           LCD_MEM,a0
        move.w        #959,d0
\loop1
        clr.l         (a0)+
        dbf.s         d0,\loop1
	rts

GetString:
        move.l        a2,a4
GetString_Start:
        move.l        a4,a2
        lea           GetString_Var1,a3
        move.b        #0,(a2)
        move.b        #0,(a3)
        clr.l         d3

GetString_GetNextKey:                       
        WriteStr      #80,#75,#4,GetString_Cst1
        WriteStr      #80,#75,#1,GetString_Var1
        cmp.b         #1,d4
        bne           GetString_NO_Power
        bsr           ShutOff
        cmp.b         #2000,d0
        beq           GetString_Clear_End
        bra           GetString_Suite
GetString_NO_Power:
        jsr           flib[idle_loop]
GetString_Suite:
        cmp.b         #13,d0
        beq           GetString_End
        cmp.b         #01,d0
        bne           GetString_Next1
        cmp           #0,d3
        beq           GetString_GetNextKey
        move.b        #0,-(a2)
        move.b        #0,-(a3)
        sub.b         #1,d3
        bra           GetString_GetNextKey
GetString_Next1:
        cmp.b         #07,d0
        bne           GetString_Next3
        bra           GetString_Start
GetString_Next3:
        cmp           #10,d3
        beq           GetString_GetNextKey
        move.b        d0,(a2)+
        add.b         #1,d3
        move.b        #0,(a2)
        move.b        #42,(a3)+
        move.b        #0,(a3)
        bra           GetString_GetNextKey
GetString_End:
        rts
GetString_Clear_End:
        move.l        a4,a2
        lea           GetString_Var1,a3
        move.b        #0,(a2)
        move.b        #0,(a3)
        clr.l         d3
	rts


tstr		dc.l	0
temps1          dc.b    0,0,0,0,0,0,0,0,0,0,0
Rebours         dc.b    0
GetString_Var1  dc.b    0,0,0,0,0,0,0,0,0,0,0
GetString_Cst1  dc.b    "          ",0
PasswordLength  dc.b    0
Password        dc.b    0,0,0,0,0,0,0,0,0,0,0
wait            dc.w    85
progn		dc.b	"Protection",0
progv           dc.b    "version 1.5",0
m1		dc.b	"[F1] Activer la protection",0
m2		dc.b	"[F2] Changer le mot de passe",0
m3              dc.b    "[F3] Option",0
m4		dc.b	"[F4] Quitter",0
nPassword       dc.b    "Entrez le nouveau mot de passe",0
limite          dc.b    "(10 caractres maximum)",0
prompt          dc.b    "Entrez le mot de passe",0
PChange1	dc.b	"Changer la valeur du compte  rebours",0
copyr		dc.b	"(c) 1997 Fock Ping Olivier",0
pname           dc.b    "Protection 1.5",0

	reloc_open
	add_library		flib
	add_library		romlib
	reloc_close
	end
